local json = require("json")
local utils = require("utils")
local utils_device = require("utils_device")
local auth = require("signature")
local query_property = require("QueryDevicePropertyStatus") 
local invoke_service = require("InvokeThingService")
local set_property = require("SetDeviceProperty")
local request_method = ngx.var.request_method

local function send_response(success, msg, code, data) 
    local ret = {}
   
    -- FIXME
    ret["RequestId"] = 123
    ret["Success"] = success
    
    if success == false then
        ret["ErrorMessage"] = msg
        ret["Code"] = code
        ngx.say(json.encode(ret))
        ngx.exit(ngx.HTTP_BAD_REQUEST)
    else
        ret["Data"] = data
        ngx.say(json.encode(ret))
        ngx.exit(ngx.HTTP_OK)
    end
end

if ("GET" == request_method) then
    local args = ngx.req.get_uri_args()
    if (nil == args) or args["Action"] == nil then
        ngx.redirect('/login');
    end

    local action = args["Action"] 
    local ret_success, ret_msg, ret_code, ret_data

    --FIXME: get password from CM.
   -- ret_success, ret_msg, ret_code = auth.is_public_request_params_valid(args)

   -- if ret_success == false then
   --     return send_response(ret_success, ret_msg, ret_code)
   -- end

    if action == "QueryDevicePropertyStatus" then
        ret_success, ret_msg, ret_code, ret_data = query_property.get_device_property_status(args["ProductKey"], args["DeviceName"]) 
    elseif action == "SetDeviceProperty" then 
        ret_success, ret_msg, ret_code, ret_data = set_property.set_property(args["ProductKey"], args["DeviceName"], args["Items"]) 
    elseif action == "InvokeThingService" then 
        ret_success, ret_msg, ret_code, ret_data = invoke_service.invoke_service(args["ProductKey"], args["DeviceName"], args["Identifier"], args["Args"]) 
    elseif action == "QueryDeviceDetail" then 
        ret_success, ret_msg, ret_code, ret_data = query_property.get_device_property_status(args["ProductKey"], args["DeviceName"]) 
    elseif action == "QueryDevice" then 
        ret_success, ret_msg, ret_code, ret_data = query_property.get_device_property_status(args["ProductKey"], args["DeviceName"]) 
    elseif action == "GetDeviceStatus" then 
        ret_success, ret_msg, ret_code, ret_data = query_property.get_device_property_status(args["ProductKey"], args["DeviceName"]) 
    elseif action == "BatchGetDeviceState" then 
        ret_success, ret_msg, ret_code, ret_data = query_property.get_device_property_status(args["ProductKey"], args["DeviceName"]) 
    elseif action == "QueryDeviceStatistics" then 
        ret_success, ret_msg, ret_code, ret_data = query_property.get_device_property_status(args["ProductKey"], args["DeviceName"]) 
    end
    
    send_response(ret_success, ret_msg, ret_code, ret_data)
end

send_response(false, "not support POST method", "", "")
